<template>
	<div v-if="state === IdentState.Error">
		<h1>Error</h1>
		<pre>{{ error }}</pre>
		<p>Please try again later. If the problem persists, contact <a rel="noopener noreferrer" href="https://www.themanaworld.org/support">Support</a>.</p>
		<br>
		<button type="button" class="button ghost" @click="state = IdentState.Overview">return</button>
	</div>
	<div v-else-if="state === IdentState.Exists">
		<h1>Already in use</h1>
		<p>This email address is already assigned to another Vault account.</p>
		<p>If you believe this is an error, contact <a rel="noopener noreferrer" href="https://www.themanaworld.org/support">Support</a>.</p>
		<br>
		<button type="button" class="button ghost" @click="state = IdentState.Overview">return</button>
	</div>
	<div v-else-if="state === IdentState.TooMany">
		<h1>Too many identities</h1>
		<p>You cannot add any more identities to your Vault.</p>
		<p>If you need assistance, contact <a rel="noopener noreferrer" href="https://www.themanaworld.org/support">Support</a>.</p>
		<br>
		<button type="button" class="button ghost" @click="state = IdentState.Overview">return</button>
	</div>
	<div v-else-if="state === IdentState.Already">
		<h1>Already validated</h1>
		<p>This email address is already assigned to your Vault account.</p>
		<br>
		<button type="button" class="button ghost" @click="state = IdentState.Overview">return</button>
	</div>
	<div v-else-if="state === IdentState.Sent">
		<h1>Check your inbox</h1>
		<p>A magic link has been sent to the email address you provided.</p>
		<p>You must click the link within 30 minutes to validate this email address.</p>
		<br>
		<button type="button" class="button ghost" @click="state = IdentState.Overview">return</button>
	</div>
	<div v-else-if="state === IdentState.Overview">
		<h1>{{ title }}</h1>
		<p>
			Identities are used to login to your Vault account and related services.
			Your primary identity is used to receive important account notifications.
			We will never send you spam, share, or sell your personal information.
			All game accounts using one of your verified email addresses are automatically linked to your Vault account.
		</p>
		<h3>Verified email addresses</h3>
		<ul v-if="identities.length > 1">
			<li v-for="(identity, index) in identities" :key="index" :class="{primary: identity.primary }">{{ identity.email }}</li>
		</ul>
		<ul v-else>
			<li v-for="(identity, index) in identities" :key="index">{{ identity.email }}</li>
		</ul>
		<button type="button" @click="state = IdentState.Add" class="button">add an email address to my Vault</button>
	</div>
	<div v-else>
		<h1 v-if="state === IdentState.Invalid">Invalid Email Address</h1>
		<h1 v-else>Email address</h1>
		<p>To proceed, you need to provide a valid email address.</p>

		<form class="gap-no read_s login" @submit.prevent="addNew">
			<div class="form-box pa_m">
				<label for="email" class="mini-label">New e-mail address</label>
				<input v-focus required autocorrect="off" name="email" id="email" ref="email" v-model="user.email" type="email" placeholder="your@email.com" class="input text_l pa_m">
			</div>
			<button class="button block text_l pa_s" type="submit" ref="submit">Verify &rarr;</button>
			<button type="button" @click="state = IdentState.Overview" class="button block text_s pa_s">Cancel</button>
		</form>
	</div>
</template>

<style scoped>
h3 {
	margin: 40px 0 0;
	&::before {
		content: "";
		width: 20px;
		height: 20px;
		display: inline-block;
		background-image: url(../assets/icons/users.svg);
		margin-right: 0.6ex;
		margin-bottom: -4px;
	}
}
ul {
	list-style-type: none;
	margin: 1em 0 1em 0;
	& li {
		font-size: 1em;
		margin-left: 1em;
		padding: .2em;
		&::before {
			content: "";
			width: 14px;
			height: 14px;
			display: inline-block;
			background-image: url(../assets/icons/user.svg);
			margin-right: 0.5ex;
			margin-bottom: -2px;
		}

		&.primary::after {
			content: "PRIMARY";
			font-size: 0.9em;
			font-style: italic;
			font-weight: bolder;
			margin-left: 8px;
			padding: 0 4px 0 4px;
			background: var(--prime-3);
			color: var(--prime-1);
			border: solid 1px green;
		}
	}
}

form {
	margin-top: 1em;
}
</style>

<script lang="ts">
import { Component, Prop, Vue } from "vue-property-decorator"

enum IdentState {
	Overview, // initial state
	Sent,     // magic link sent
	Error,    // misc error
	Add,      // request to add an identity
	Invalid,  // invalid email address
	Exists,   // already assigned to another user
	Already,  // user already owns this
	TooMany,  // too many identities
}

@Component({
	data () {
		return { IdentState }
	},
	computed: {
		identities () {
			return this.$store.state.identities
		},
	},
})
export default class EmailIdentities extends Vue {
	@Prop() private title!: string
	state = IdentState.Overview
	error = ""
	user = {
		email: "",
	}

	async created () {
		// TODO: send an etag so that the api can say if the data is unchanged and avoid re-sending it
		const req = new Request(`${process.env.VUE_APP_API}/vault/identity`, {
			method: "GET",
			mode: "cors",
			cache: "no-cache",
			redirect: "follow",
			referrer: "no-referrer",
			headers: {
				"Accept": "application/json",
				"X-VAULT-SESSION": this.$store.state.session.sessionKey,
				"X-VAULT-TOKEN": this.$store.state.session.secretKey,
			},
		})

		let rawResponse

		try {
			rawResponse = await fetch(req)
		} catch (err) {
			void err
			// TODO: actually handle this
			return
		}

		const json = await rawResponse.json()

		if (Reflect.has(json, "session")) {
			this.$store.commit("expiry", json.session.expires)
		}

		switch (rawResponse.status) {
		default:
			// TODO: handle errors
			break
		case 200:
			this.$store.commit("setIdentities", json.identities)
			return
		case 410:
			this.$store.commit("session", {})
			this.$router.push({name: "login", params: {expired: "true"}})
			return
		}
	}

	async addNew () {
		for (const ident of this.$store.state.identities) {
			if (this.user.email === ident.email) {
				this.state = IdentState.Already
				return
			}
		}

		const submit = this.$refs.submit as HTMLButtonElement
		submit.disabled = true

		const req = new Request(`${process.env.VUE_APP_API}/vault/identity`, {
			method: "POST",
			mode: "cors",
			cache: "no-cache",
			redirect: "follow",
			referrer: "no-referrer",
			headers: {
				"Accept": "application/json",
				"Content-Type": "application/json",
				"X-VAULT-SESSION": this.$store.state.session.sessionKey,
				"X-VAULT-TOKEN": this.$store.state.session.secretKey,
			},
			body: JSON.stringify({
				email: this.user.email,
			}),
		})

		let rawResponse

		try {
			rawResponse = await fetch(req)
		} catch (err) {
			this.state = IdentState.Error
			this.error = "Couldn't reach the API"
			console.error(err)
			return
		}

		const json = await rawResponse.json()

		if (Reflect.has(json, "session")) {
			this.$store.commit("expiry", json.session.expires)
		}

		submit.disabled = false

		switch (rawResponse.status) {
		case 200:
			await this.$store.commit("setLoginAttempt", this.user.email)

			if (Reflect.has(json, "key")) {
				// the API doesn't require a formal validation (local testing only)
				this.$router.replace({name: "validation", params: {key: json.key, redirect: "vault"}})
				return
			}

			this.state = IdentState.Sent
			return
		case 400:
			this.state = IdentState.Invalid
			break
		case 401:
			this.$store.commit("session", {})
			this.$router.push({name: "login", params: {expired: "true"}})
			return
		case 409:
			this.state = IdentState.Exists
			break
		case 410:
			this.$store.commit("session", {})
			this.$router.push({name: "login", params: {expired: "true"}})
			return
		case 416:
			this.state = IdentState.TooMany
			break
		//case 425:
		case 429:
			this.state = IdentState.Error
			this.error = "Too many requests"
			return
		case 500:
			this.state = IdentState.Error
			this.error = "Internal server error"
			return
		case 502:
			this.state = IdentState.Error
			this.error = "The API is unreachable"
			return
		default:
			this.state = IdentState.Error
			this.error = `Unknown error: ${rawResponse.status}`
			return
		}
	}
}
</script>
